#include <boarddefs.h>
#include <IRremoteInt.h>
#include <IRremote.h>
#include <ir_Lego_PF_BitStreamEncoder.h>

#define STANDBY  30

#define INA1    28
#define INA2    26
#define PWMA    5

#define INB1    32
#define INB2    34
#define PWMB    6

const byte TRIGGER_PIN = 22; // Broche TRIGGER
const byte ECHO_PIN = 24; // Broche ECHO  
int distmin = 10 ;
const float SOUND_SPEED = 340.0 / 1000;
int led1 = 12;
int led = 10;
int led2 = 11;
int vitesse;


IRsend irsend; 

void setup(void){
pinMode(led, OUTPUT); 
Serial.begin(9600);
pinMode(STANDBY,OUTPUT);
pinMode(INA1,OUTPUT);
pinMode(INA2,OUTPUT);
pinMode(PWMA,OUTPUT);
pinMode(INB1,OUTPUT);
pinMode(INB2,OUTPUT);
pinMode(PWMB,OUTPUT);
pinMode(TRIGGER_PIN, OUTPUT);
pinMode(led, OUTPUT);
pinMode(ECHO_PIN, INPUT);
}

void loop(void){
  
  // prog led IR 
  
{
    irsend.sendRC5(0x68B92, 20);
    delay(10);
    irsend.sendRC5(0x68B92, 20);
    delay(10);
    irsend.sendRC5.(0x68B92, 20);
    delay(300);
}
 
 //prog ultrason
 
 
 digitalWrite(TRIGGER_PIN, LOW); 
 delayMicroseconds(2);
 /* 1. Lance une mesure de distance en envoyant une impulsion HIGH de 10µs sur la broche TRIGGER */
 digitalWrite(TRIGGER_PIN, HIGH);
 delayMicroseconds(10);
 digitalWrite(TRIGGER_PIN, LOW);
 digitalWrite(led1, LOW);
 /* 2. Mesure le temps entre l'envoi de l'impulsion ultrasonique et son écho (si il existe) */
 long measure = pulseIn(ECHO_PIN,HIGH,100000);
  
 /* 3. Calcul la distance à partir du temps mesuré */
 float distance_cm = measure*0.034/2;
// Serial.print("temps: ");
// Serial.println(measure);
// Serial.print("Distance: ");
// Serial.println(distance_cm);
 delay(50);
// 
 
 //Prog moteurs
 
 if (distance_cm < distmin)

 {  digitalWrite(led1,HIGH) ;
    digitalWrite(INA1,HIGH);
    digitalWrite(INA2,LOW);
    analogWrite(PWMA,0);
    digitalWrite(INB1,HIGH);
    digitalWrite(INB2,LOW);
    analogWrite(PWMB,200);
    Serial.println("tourne");
    delay(1000);
    analogWrite(PWMA,200);
   
 }
 else {
   if(Serial.available()>0)
   {
   Serial.println("ordre");
   digitalWrite(led2, HIGH);   // turn the LED on (HIGH is the voltage level)
   delay(100);               // wait for a second
   digitalWrite(led2, LOW);    // turn the LED off by making the voltage LOW
   delay(100);
 
   unsigned char actions=Serial.read();
   digitalWrite(STANDBY,HIGH);
   digitalWrite(INA1,HIGH);
   digitalWrite(INA2,LOW);
   digitalWrite(INB1,HIGH);
   digitalWrite(INB2,LOW);
   Serial.println(actions);
   
   //prog modulation vitessse
   
    if((actions == 98) || (actions == 99) || (actions == 97) )
    {
     switch(actions){
        case 'a' : vitesse= 0; break; 
        case 'b' : vitesse= 128; break; 
        case 'c' : vitesse= 255; break;
     } 
    }
   
   
   if(actions == 48)//avance
    {
      analogWrite(PWMA,vitesse);
      analogWrite(PWMB,vitesse);
    }
    else if (actions == 50)//tourne droite
    { 
      analogWrite(PWMA,0);
      analogWrite(PWMB,vitesse);
      delay(1000);
      analogWrite(PWMA,vitesse);
      
    }
    else if (actions == 51)//tourne gauche
    {
      analogWrite(PWMA,vitesse); 
      analogWrite(PWMB,0);
      delay(1000);
      analogWrite(PWMB,vitesse);
      
    }
    else if (actions == 49)//Recule
    {
      digitalWrite(INA1,LOW);
      digitalWrite(INA2,HIGH);
      analogWrite(PWMA,vitesse);
      digitalWrite(INB1,LOW);
      digitalWrite(INB2,HIGH);
      analogWrite(PWMB,vitesse);
    }

  }
 }
}
